# JointSU 0.1   2008.11.16   by   Marcio de A. Braga
# 
require 'sketchup.rb'
include Math

class Test2

def initialize
	@p0=Geom::Point3d.new(0.0,0.0,0.0) # auxiliar para a construcao dos vetores
	@msg=[]
	@msg[0]="falta mensagem"
	@msg[1]="1 Select Components with Joint [OR] Selected Components to change Joint"
	@msg[2]="2 Move: Shit Click on Fix Component [OR] Select Components to change Joint"
	end
def fale(n)
	Sketchup.set_status_text(@msg[n], SB_PROMPT)
	end
def activate
	@model = Sketchup.active_model
	@entities=@model.active_entities
	@sels=@model.selection
	limpa
	end
def deactivate(view)
	@sels.clear
	end
def limpa
	@moveu=false
	@compo1=nil
	@compo2=nil
	@junta1=nil
	@junta2=nil
	@numJunta1=0
	@numJunta2=0
	@sels.clear
	fale(1)
	end
def testa(pick)
	num_juntas=0
	@compo=nil
	@junta=nil
	if pick.typename == "ComponentInstance" then
		pick.definition.entities.each do |elemento|
			if elemento.typename == "ComponentInstance" then
				if elemento.definition.name=="JointSU" then
					@compo=pick
					@junta=elemento
					num_juntas=num_juntas+1
				end
			end
		end
	end
	num_juntas
	end
def pega(compX,num)
	numCheck=0
	resposta=nil
	compX.definition.entities.each do |elemento|
		if elemento.typename == "ComponentInstance" then
			if elemento.definition.name=="JointSU" then
				if num==numCheck then
					resposta=elemento
					break
				end
				numCheck=numCheck+1
			end
		end
	end
	resposta
	end

def onLButtonDown(flag, x, y, view)
	# 0=none / 1=Left / 2=Right / 4=Shift / 8=Ctrl / 16=??? / 32=Alt  / Alt Gr = alt + ctrl
	ph=@model.active_view.pick_helper
	n=ph.do_pick(x,y)
	if n!=0 then # entrada no bloco "pegou alguma coisa"
		n_juntas=testa(ph.best_picked)
		if flag==1 then # click simples
			if @moveu==true then
				if @compo==@compo2 or @compo=@compo1 then
					transf2 = Geom::Transformation.rotation(@p1,@vz1,Math::PI/2.0)
					@compo2.transform!(transf2)
				end
			else # antes de mover ....
				if n_juntas != 0 then # pegou componente com junta(s)
					if @compo==@compo1 then # pegou o compo1
						if n_juntas != 1 then # proxima junta
							@numJunta1=@numJunta1+1
							@numJunta1=0 if @numJunta1==n_juntas
							x=pega(@compo1,@numJunta1)
							if x!=nil then
								@sels.remove(@junta1) if @junta1!=@junta2
								@junta1=x
								@sels.add(@junta1)
								if @compo2==nil then fale(1) else fale(2) end
							else
								p "PROBLEMA 1"
								limpa
							end
						else # aqui nao tem nada a fazer
							# nada
						end
					elsif @compo==@compo2 #pegou o compo2
						if n_juntas != 1 then # proxima junta
							@numJunta2=@numJunta2+1
							@numJunta2=0 if @numJunta2==n_juntas
							x=pega(@compo2,@numJunta2)
							if x!=nil then
								@sels.remove(@junta2) if @junta1!=@junta2
								@junta2=x
								@sels.add(@junta2)
								fale(2)
							else
								p "PROBLEMA 2"
								limpa
							end
						else # aqui nao tem nada a fazer
							# nada
						end
					else # pegou compo com junta mas nao  nem o compo1 nem o compo2
						if @compo1==nil then #  aqui que a coisa comeca - seleciona esse entao 
							@compo1=@compo
							@numJunta1=0
							x=pega(@compo1,@numJunta1)
							if x!=nil then
								@junta1=x
								@sels.add(@compo1)
								@sels.add(@junta1)
								fale(1)
							else
								p "PROBLEMA 3"
								limpa
							end
						elsif @compo2==nil # seleciona esse entao
							@compo2=@compo
							@numJunta2=0
							x=pega(@compo2,@numJunta2)
							if x!=nil then
								@junta2=x
								@sels.add(@compo2)
								@sels.add(@junta2)
								fale(2)
							else
								p "PROBLEMA 4"
								limpa
							end
						else # ja tem compo1 e compo2 e pegou um outro compo com junta ... que fazer ?
							# nada
						end
					end
				else # pegou um componente sem juntas
					# nada
				end # fim do pegou um componente
			end # fim do bloco flag==1	
		elsif flag==5 then # click com Shift = quer executar
			if @moveu==true then
				if @compo==@compo2 or @compo=@compo1 then
					transf2 = Geom::Transformation.rotation(@p1,@vx1,Math::PI/2.0)
					@compo2.transform!(transf2)
				end
			else
				if @compo1 != nil and @compo2 != nil and @junta1 != nil and @junta2 != nil then
					if @compo==@compo2 then
						a=@compo1
						b=@junta1
						@compo1=@compo2
						@junta1=@junta2
						@compo2=a
						@junta2=b
					end
					movimenta
					@moveu=true
				else
					p "PROBLEMA 5"
				end # fim do bloco flag==5
			end
		else # click com outra tecla que nao o Shift
			# nada
		end # fim do bloco "pegou alguma coisa"
	else # entrada no bloco "nao pegou nada"
		limpa
	end # fim dos blocos "pegou algo" ou "nao pegou nada"	
	end	 # fim da funcao onButton
def movimenta
	# Origem da J1 (componente fixo) (em coordenadas globais)
	# obs: por enquanto estamos trabalhando com componentes de 1o nivel apenas
	i1=@compo1.transformation.to_a # pega a matrix da instancia I1
	j1=@junta1.transformation.to_a # pega a matrix da junta J1
	xG=i1[12]+i1[0]*j1[12]+i1[4]*j1[13]+i1[8]*j1[14]
	yG=i1[13]+i1[1]*j1[12]+i1[5]*j1[13]+i1[9]*j1[14]
	zG=i1[14]+i1[2]*j1[12]+i1[6]*j1[13]+i1[10]*j1[14]
	@p1=Geom::Point3d.new(xG,yG,zG) # Ponto (em coordenadas Globais) da Origem da Junta (J1 no caso)

	# Vetor X da J1 (componente fixo) (em coordenadas Globais) 
	xG=i1[0]*j1[0]+i1[4]*j1[1]+i1[8]*j1[2]
	yG=i1[1]*j1[0]+i1[5]*j1[1]+i1[9]*j1[2]
	zG=i1[2]*j1[0]+i1[6]*j1[1]+i1[10]*j1[2]
	p3=Geom::Point3d.new(xG,yG,zG)
	@vx1 = @p0.vector_to(p3) # vetor que da a direcao X da J1

	# Vetor Z da J1 (componente fixo) (em coordenadas Globais)
	xG=i1[0]*j1[8]+i1[4]*j1[9]+i1[8]*j1[10]
	yG=i1[1]*j1[8]+i1[5]*j1[9]+i1[9]*j1[10]
	zG=i1[2]*j1[8]+i1[6]*j1[9]+i1[10]*j1[10]
	pz1=Geom::Point3d.new(xG,yG,zG)
	@vz1 = @p0.vector_to(pz1) # vetor que da a direcao Z da J1
		
	# Origem da J2 (componente movel) (em coordenadas Globais)
	i2=@compo2.transformation.to_a # pega a matrix da instancia I2
	j2=@junta2.transformation.to_a # pega a matrix da junta J2
	xG=i2[12]+i2[0]*j2[12]+i2[4]*j2[13]+i2[8]*j2[14]
	yG=i2[13]+i2[1]*j2[12]+i2[5]*j2[13]+i2[9]*j2[14]
	zG=i2[14]+i2[2]*j2[12]+i2[6]*j2[13]+i2[10]*j2[14]
	p2=Geom::Point3d.new(xG,yG,zG)

	@compo2.transform!(p2.vector_to(@p1)) # move I2 de acordo com vetor P2->P1, ou seja, a origem da junta J2 deve estar sobre a origem de J1

	# Vetor X da J2 (componente movel) (em coordenadas Globais)
	# obs: a matriz do Compo2 mudou, mas como a transf nao alterou nenhuma rotacao, a matriz antiga ainda serve para esse calculo
	xG=i2[0]*j2[0]+i2[4]*j2[1]+i2[8]*j2[2]
	yG=i2[1]*j2[0]+i2[5]*j2[1]+i2[9]*j2[2]
	zG=i2[2]*j2[0]+i2[6]*j2[1]+i2[10]*j2[2]
	p4=Geom::Point3d.new(xG,yG,zG)
	vx2 = @p0.vector_to(p4) # vetor que da a direcao X da J2
	
	angulo=vx2.angle_between(@vx1) # angulo absoluto entre as direcoes X
	#p "Angulo X: #{angulo*180.0/Math::PI}"
	
	#if angulo !=0.0 then # se o ang  0 nao tem que fazer nada
		if angulo==0.0 or angulo==Math::PI then # se o ang  180, girar em torno de Z da Junta1
			vn=@vz1 # vetor normal nesse caso  o vetor Z da Junta1 - tanto faz o sentido pois o giro  de 180
		else # se ang qquer a construcao do vetor normal  que da o sentido de giro
			vn=vx2*@vx1 # vetor normal a vx2 e vx1 (nesse sentido de rotacao .. de vx2 para vx1)
		end
		transf2 = Geom::Transformation.rotation(@p1,vn,angulo+Math::PI)
		@compo2.transform!(transf2) # agora os 2 vetores X devem estar alinhados
	#end
	# a partir daqui a direcao X das Juntas estao alinhadas
	
	# Como o Compo2 mudou,  necessario pegar sua matriz novamente
	i2=@compo2.transformation.to_a # pega a matrix da instancia I2
	j2=@junta2.transformation.to_a # pega a matrix da junta J2

	# Vetor Z da J2 (componente movel) (em coordenadas Globais)
	xG=i2[0]*j2[8]+i2[4]*j2[9]+i2[8]*j2[10]
	yG=i2[1]*j2[8]+i2[5]*j2[9]+i2[9]*j2[10]
	zG=i2[2]*j2[8]+i2[6]*j2[9]+i2[10]*j2[10]
	p7=Geom::Point3d.new(xG,yG,zG)
	vz2=@p0.vector_to(p7) # vetor que da a direcao Z da J2

	angulo=vz2.angle_between(@vz1) # angulo absoluto entre as direcoes Z
	#p "Angulo Z: #{angulo*180.0/Math::PI}"
	if angulo !=0.0 then # se o ang  0 nao tem que fazer nada
		if angulo==Math::PI then # se o ang  180, girar em torno de X da Junta1
			vn=@vx1 # vetor normal nesse caso  o vetor X da Junta1 - tanto faz o sentido pois o giro  de 180
		else
			vn=vz2*@vz1 # vetor normal a vz2 e vz1 (nesse sentido de rotacao .. de vz2 para vz1)
		end
		transf3 = Geom::Transformation.rotation(@p1,vn,angulo)
		@compo2.transform!(transf3)
	end
	end		
end # class Test1
#v61=v6.clone
#v61.length=2000.0
#@entities.add_cline(p1,p1.offset(v61))

def t3
	k=10
	compo=Sketchup.active_model.definitions.add ("JointSU")
	compo.entities.add_cline([0,0,0],[5*k,0,0])
	compo.entities.add_face([0,-k,0],[k,0,0],[0,k,0])
	compo.entities.add_face([0,0,k],[0,0,0],[k,0,0])
	end
def t4
	tt(false)
	end
def t5
	tt(true)
	end
def tt(condicao)
	model=Sketchup.active_model
	sels=model.selection
	sels.clear
	model.entities.each do |n| 
		if n.typename == "ComponentInstance" then
			n.definition.entities.each do |j|
				if j.typename == "ComponentInstance" then
					if j.definition.name=="JointSU" then
						sels.add(j)
						j.visible=condicao
					end
				end
			end
		end
	end
	end
def t2
	myTool=Sketchup.active_model.select_tool(Test2.new)
	end
if not file_loaded?("JointSU.rb")
	cmd = UI::Command.new("Mama12") { t2 }
	cmd.small_icon = "OOT_icons/JointSU_16.png"
	cmd.large_icon = "OOT_icons/JointSU_24.png"
	cmd.menu_text = "Mama menu text"

	cmd.tooltip = "JointSU"
	cmd.status_bar_text = "JointSU: Move components Joint-to-Joint"
	mamaBar = UI::Toolbar.new("MamaTools")
	mamaBar.add_item(cmd)
	mamaMenu = UI.menu("Plugins")
	mamaSubMenu = mamaMenu.add_submenu("JointSU")
	mamaSubMenu.add_item("create JointSU component") { t3 }
	mamaSubMenu.add_item("Hidden all JointSU") { t4 }
	mamaSubMenu.add_item("Visible all JointSU") { t5 }
end
file_loaded("JointSU.rb")